//Throwable sandvich plugin by Lorgan3
//This is a -REQUIRED- server-sent plugin (it won't break clients if they don't have it though)
sandvichPath = argument0;

if file_exists(sandvichPath+"\Sandvich.png") global.sandvichSprite = sprite_add(sandvichPath+"\Sandvich.png",1,1,0,5,4);
else global.sandvichSprite = MedAlert;

if file_exists(sandvichPath+"\SandvichBubble.png") {
    global.sandvichBubbleOffset = sprite_get_number(BubblesS);
    sprite_merge(BubblesS,sprite_add(sandvichPath+"\SandvichBubble.png",1,1,0,1,18));
} else global.sandvichBubbleOffset = 43;
    
global.sandvich = object_add();
object_event_add(global.sandvich,ev_create,0,"
    sprite_index = global.sandvichSprite;
    image_speed = 0;
    hfric = 0.4;
    alarm[0] = 210;
    alarm[1] = 5;
    canEat = false;
    speed = random(5)+1;
");
object_event_add(global.sandvich,ev_alarm,0,"instance_destroy();");
object_event_add(global.sandvich,ev_alarm,1,"canEat = true;");
object_event_add(global.sandvich,ev_collision,Character,"
    //heal 40 hp if possible.
    if other.hp < other.maxHp && canEat {
        setChatBubble(other.player, global.sandvichBubbleOffset);
        playsound(x,y,PickupSnd)
        other.hp = min(other.hp+40,other.maxHp);
        instance_destroy();
    }
");
object_event_add(global.sandvich,ev_step,ev_step_normal,"
    if(abs(vspeed)<0.2) vspeed=0;
    if(place_free(x,y+1)) vspeed += 0.7
    if(vspeed>11) vspeed=11;
");
object_event_add(global.sandvich,ev_collision,Obstacle,"
    hspeed*=hfric;
        
    move_contact_solid(point_direction(x,y,x+hspeed,y+vspeed), speed);
    if(not place_free(x,y+sign(vspeed))) {
        vspeed*=-0.4;
        if(not place_free(x+hspeed,y)){
            move_contact_solid(point_direction(x,y,x+hspeed,y+vspeed), speed);
            hspeed*=-0.4;
        }
    }
    if(not place_free(x+sign(hspeed),y)){
        hspeed*=-0.4;
        if(not place_free(x,y+vspeed)) {
            move_contact_solid(point_direction(x,y,x+hspeed,y+vspeed), speed);
            vspeed*=-0.4;
        }
    }
");

//Throw a sandvich by pressing m1+m2;
object_event_add(Character,ev_create,0,"omnomnomnomindex = 0");
object_event_add(Character,ev_step,ev_step_normal,"
    if omnomnomnom == true && (omnomnomnomindex == 0 || omnomnomnomindex == 32) {
        if (keyState & $10 != 0) {  //m1
            omnomnomnom = false;
            sub = instance_create(x,y,global.sandvich);
            sub.direction = aimDirection;
            canEat = false; //add 10 seconds even if his hp was at max
            alarm[6] += 300; //10 second penalty for throwing it
        } 
    }
");
